/* Agent Tcl
   Bob Gray
   10 January 1996

   tclParse.h

   This file defines various parsing routines.

   Copyright (c) 1995-1996, Bob Gray, Dartmouth College

   See the file "agent.terms" for information on usage and redistribution
   of this file and for a DISCLAIMER OF ALL WARRANTIES.
*/

#ifndef _TCL_PARSE_H
#define _TCL_PARSE_H

#ifndef NO_PRAGMAS
#pragma interface
#endif

#undef CONST

#ifdef __cplusplus
#define CONST const
#else
#define CONST
#endif

struct Tcl_Interp;
#ifdef TCL8
struct Tcl_Obj;
#endif

#define INFINITY 31557600.0

int parseShortTimeout 
	(Tcl_Interp *interp, double &seconds, int argc, char **argv, int i);

int parseTimeout 
	(Tcl_Interp *interp, double &seconds, int argc, char **argv, int i);

#ifdef TCL8

int parseShortTimeoutObj
	(Tcl_Interp *interp, double &seconds, int objc, Tcl_Obj *CONST objv[], 
	 int i);

int parseTimeoutObj
	(Tcl_Interp *interp, double &seconds, int objc, Tcl_Obj *CONST objv[], 
	 int i);

#endif

#undef CONST
#endif
